/*
*        create structure database hmgtest
*/
FUNCTION p001_main()
   p001_mainloop()
RETURN NIL

STATIC FUNCTION p001_mainloop()
IF MSGYESNO("ATTENTION! Do you want to continue ?") == .T.
  p001_hmgtbtest()
ENDIF
RETURN NIL

/*
* create tab hmgtbtest
*/
STATIC FUNCTION p001_hmgtbtest()
LOCAL sString := ""
LOCAL oRs1p001 := CreateObject("ADODB.recordset")
oRs1p001:CursorType = adOpenStatic
oRs1p001:CursorLocation = adUseClient
oRs1p001:LockType = adLockOptimistic
oRs1p001:ActiveConnection(@oPrjcon)

sString := "DROP TABLE IF EXISTS hmgtbtest;"
IF l3w_AdoConExecut(@oPrjcon, sString)==.T.
  sString := "CREATE TABLE `hmgtbtest` (" + ;
             "`admintstp` TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Upd.timer'," + ;
             "`prgcodice` CHAR( 8 ) NOT NULL COMMENT 'code'," + ;
             "`prgdescri` CHAR( 50 ) NOT NULL COMMENT 'descr'," + ;
             "PRIMARY KEY ( `prgcodice` )" + ;
             ") ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_unicode_ci COMMENT = 'example';"
  IF l3w_AdoConExecut(@oPrjcon, sString) == .T.
    sString := "SELECT * FROM hmgtbtest ;"
    IF l3w_AdoRsetOpen(@oRs1p001, sString) == .T.
      IF l3w_AdoRsetAdnew(@oRs1p001) == .T.
        oRs1p001:Fields("prgcodice"):value := "ONECODE1"
        oRs1p001:Fields("prgdescri"):value := "One description"
        IF l3w_AdoRsetUpdate(@oRs1p001)==.F.
          MSGSTOP("I can't UPDATE ONECODE1")
        ENDIF
      ELSE
        MSGSTOP("I can't ADD ONECODE1")
      ENDIF
      l3w_AdoRsetClose(@oRs1p001)
    ELSE
      MSGSTOP("I can't open recordset on hmgtbtest")
    ENDIF
  ELSE
    MSGSTOP("I can't CREATE hmgtbtest")
  ENDIF
ELSE
  MSGSTOP("I can't DROP hmgtbtest")
ENDIF
RETURN NIL