/*
* This program do the maintenance of the records
*/
FUNCTION p002_main()
p002_mainloop()
RETURN NIL

STATIC FUNCTION p002_mainloop()
oRs1p002 := TOleauto():New('ADODB.recordset')
oRs1p002:CursorType = adOpenStatic
oRs1p002:CursorLocation = adUseClient
oRs1p002:LockType = adLockOptimistic
* Do You remember oPrjcon? See mainp000 at the top
oRs1p002:ActiveConnection(@oPrjcon)
p002_lRecexist := .F.

DEFINE WINDOW p002win ;
  AT 0,0 ;
  WIDTH 940 ;
  HEIGHT 705 ;
  TITLE "Records maintenance" ;
  ICON 'icologo' ;
  CHILD ;
  NOMAXIMIZE ;
  NOMINIMIZE ;
  ON INIT p002_init() ;
  ON RELEASE p002_exit();
  FONT "Arial" ;
  SIZE 10

* toolbar
  DEFINE TOOLBAR toolbar1 ;
    BUTTONSIZE 60,60 ;
    IMAGESIZE 32, 32 ;
    FONT "Arial" ;
    SIZE 8 ;
    FLAT ;
    BORDER
    BUTTON bt_exit ;
      CAPTION 'e&Xit' ;
      PICTURE 'MINIGUI_EDIT_CLOSE' ;
      ACTION p002win.release ;
      TOOLTIP 'Exit' ;
      SEPARATOR
    BUTTON bt_save ;
      CAPTION '&Save' ;
      PICTURE 'MINIGUI_EDIT_OK' ;
      ACTION p002_save() ;
      TOOLTIP 'Save' ;
      SEPARATOR
    BUTTON bt_quit ;
      CAPTION '&Quit' ;
      PICTURE 'MINIGUI_EDIT_NEW' ;
      ACTION p002_unloadrec() ;
      TOOLTIP 'Quit' ;
      SEPARATOR
    BUTTON bt_dele ;
      CAPTION '&Delete' ;
      PICTURE 'MINIGUI_EDIT_DELETE' ;
      ACTION p002_delete() ;
      TOOLTIP 'Delete' ;
      SEPARATOR
  END TOOLBAR

* Code Primary Key
  @ 090,020 LABEL lb_prgcodice ;
    VALUE 'Code' ;
    WIDTH 100 ;
    HEIGHT 25
  @ 090,125 TEXTBOX prgcodice ;
    WIDTH 100 ;
    HEIGHT 25 ;
    TOOLTIP 'Code' ;
    UPPERCASE ;
    MAXLENGTH 8 ;
    ON ENTER p002_loadrec()
*  search2
  @ 090,230 BUTTON bt_search2 ;
    PICTURE 'MINIGUI_EDIT_FIND' ;
    WIDTH 20 ;
    HEIGHT 20 ;
    ONCLICK {|| p002_search2()} ;
    FLAT ;
    NOTABSTOP

* campo prgdescri
  @ 120,020 LABEL lb_prgdescri ;
    VALUE 'Nome' ;
    WIDTH 100 ;
    HEIGHT 25
  @ 120,125 TEXTBOX prgdescri ;
    WIDTH 300 ;
    HEIGHT 25 ;
    TOOLTIP 'Name' ;
    MAXLENGTH 50

END WINDOW
CENTER WINDOW p002win
ACTIVATE WINDOW p002win

RETURN NIL

/*
* form fields init
*/
STATIC FUNCTION p002_init()
p002win.prgcodice.value := ""
p002win.prgdescri.value := ""

p002win.prgcodice.enabled := .T.
p002win.prgdescri.enabled := .F.

p002win.bt_save.enabled := .F.
p002win.bt_quit.enabled := .F.
p002win.bt_dele.enabled := .F.
p002win.bt_search2.enabled := .T.

p002win.prgcodice.setfocus
RETURN NIL

/*
* exit
*/
STATIC FUNCTION p002_exit()
l3w_AdoRsetClose(@oRs1p002)
oRs1p002 := NIL
RETURN NIL

/*
* search2
*/
STATIC FUNCTION p002_search2()
LOCAL aReturn := {}
aReturn := p003_main()
IF LEN(aReturn)==1
  p002win.prgcodice.value := aReturn[1]
ENDIF
p002win.prgcodice.setfocus
RETURN NIL

/*
* load record
*/
STATIC FUNCTION p002_loadrec()
LOCAL sString := ""
p002_lRecexist := .F.
sString := "SELECT * FROM hmgtbtest " + ;
           "WHERE prgcodice='" + ALLTRIM(p002win.prgcodice.value) + "';"
IF l3w_AdoRsetOpen(@oRs1p002, sString)==.T.
  IF oRs1p002:EOF==.F. .AND. oRs1p002:BOF==.F.
    p002win.prgdescri.value := HB_UTF8TOSTR( oRs1p002:Fields("prgdescri"):value )
    p002_lRecexist := .T.
  ENDIF
  p002_enable()
ELSE
  MSGSTOP("Error on recordset","p002_loadrec()")
ENDIF
RETURN NIL


/*
* enable form fields and buttons
*/
STATIC FUNCTION p002_enable()
p002win.prgcodice.enabled := .F.
p002win.prgdescri.enabled := .T.
p002win.bt_save.enabled := .T.
p002win.bt_quit.enabled := .T.
p002win.bt_search2.enabled := .F.
p002win.prgdescri.setfocus
RETURN NIL

/*
* unload record
*/
STATIC FUNCTION p002_unloadrec()
l3w_AdoRsetClose(@oRs1p002)
p002_init()
RETURN NIL

/*
* save record
*/
STATIC FUNCTION p002_save()
LOCAL lProceed := .T.
IF p002_lRecexist == .F. .AND. l3w_AdoRsetAdnew(@oRs1p002) == .F.
  lProceed := .F.
  MSGSTOP("I can't add record","p002_save()")
ENDIF
IF lProceed==.T.
  oRs1p002:Fields("prgcodice"):value := HB_STRTOUTF8( ALLTRIM(p002win.prgcodice.value) )
  oRs1p002:Fields("prgdescri"):value := HB_STRTOUTF8( ALLTRIM(p002win.prgdescri.value) )
  IF l3w_AdoRsetUpdate(@oRs1p002)==.F.
    MSGSTOP("I can't update record","p002_save()")
  ELSE
    p002_unloadrec()
  ENDIF
ENDIF
RETURN NIL

/*
* delete
*/
STATIC FUNCTION p002_delete()
IF p002_lRecexist == .T. .AND. l3w_AdoRsetDelete(@oRs1p002) == .F.
  MSGSTOP("I can't delete record","p002_delete()")
ELSE
 p002_unloadrec()
ENDIF
RETURN NIL
