/*
* This program do the record selection
*/
FUNCTION p003_main()
PRIVATE aReturn := {}
p003_mainloop()
RETURN aReturn

STATIC FUNCTION p003_mainloop()
oRs1p003 := TOleauto():New('ADODB.recordset')
oRs1p003:CursorType = adOpenStatic
oRs1p003:CursorLocation = adUseClient
oRs1p003:LockType = adLockOptimistic
oRs1p003:ActiveConnection(@oPrjcon)


* SET NAVIGATION EXTENDED
DEFINE WINDOW p003win ;
  AT 0,0 ;
  WIDTH 800 ;
  HEIGHT 600 ;
  TITLE "Records maintenance" ;
  ICON 'icologo' ;
  CHILD ;
  NOMAXIMIZE ;
  NOMINIMIZE ;
  ON INIT p003_init() ;
  ON RELEASE p003_exit();
  FONT "Arial" ;
  SIZE 10

* definizione toolbar
  DEFINE TOOLBAR toolbar1 ;
    BUTTONSIZE 60,60 ;
    IMAGESIZE 32, 32 ;
    FONT "Arial" ;
    SIZE 8 ;
    FLAT ;
    BORDER
    BUTTON bt_exit ;
      CAPTION 'e&Xit' ;
      PICTURE 'MINIGUI_EDIT_CLOSE' ;
      SEPARATOR ;
      ACTION p003win.release
  END TOOLBAR

  @ 060,020 GRID Grid1 ;
    WIDTH 600 ;
    HEIGHT 330 ;
    HEADERS {'Code','Description'} ;
    WIDTHS {100,250} ;
    ON DBLCLICK p003_select() ;
    ON HEADCLICK { {||p003_order(1)} , {||p003_order(2)} } ;
    TOOLTIP 'DoubleClick=Select record, HeadClick=change order'

END WINDOW
CENTER WINDOW p003win
ACTIVATE WINDOW p003win

RETURN NIL

/*
* inizializzazione maschera
*/
STATIC FUNCTION p003_init()
p003_order(2)
RETURN NIL

/*
* uscita
*/
STATIC FUNCTION p003_exit()
l3w_AdoRsetClose(@oRs1p003)
oRs1p003 := NIL
RETURN NIL

/*
* selezione
*/
STATIC FUNCTION p003_select()
LOCAL nI := 0, aGridrow := {}
nI := p003win.Grid1.Value
IF nI != 0
  aGridRow := p003win.Grid1.Item(nI)
  AADD(aReturn, aGridRow[1])
  p003win.release
ENDIF
RETURN

/*
* estrazione in base all'ordinamento
*/
STATIC FUNCTION p003_order(nOrdine)
LOCAL sString := ""
sString := "SELECT * FROM hmgtbtest "
IF nOrdine==2
  sString += "ORDER BY prgdescri;"
ELSE
  sString += "ORDER BY prgcodice;"
ENDIF
l3w_AdoRsetClose(@oRs1p003)
IF l3w_AdoRsetOpen(@oRs1p003, sString)==.T.
  p003win.Grid1.DeleteAllItems
  DO WHILE !oRs1p003:EOF
*    p003win.Grid1.AddItem( {oRs1p003:Fields("prgcodice"):value, oRs1p003:Fields("prgdescri"):value} )
    p003win.Grid1.AddItem( {HB_UTF8TOSTR( oRs1p003:Fields("prgcodice"):value ), HB_UTF8TOSTR(oRs1p003:Fields("prgdescri"):value ) } )
    l3w_AdoRsetMnext(@oRs1p003)
  ENDDO
ELSE
  MSGSTOP("I can't open rcordset","p003_order")
ENDIF
RETURN NIL